﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;


namespace Project_VolgaIT
{
    public partial class Form1 : Form
    {
        int GlobalWidth = Settings.Default.Width;
        int GlobalHeight = Settings.Default.Height;
        int?[,] Opponents;
        Player igrok = new Player(0, 0);

        public Form1()
        {
            InitializeComponent();
            Opponents = new int?[GlobalWidth, GlobalHeight];
            initialArr();
            UpdateAll();
        }
        private void initialArr()
        {
            Opponents[2, 2] = 11;
            Opponents[3, 4] = 10;
            Opponents[0, 1] = 12;
            Opponents[3, 0] = 0;
        }

        private void UpdateAll()
        {
            pictureBox1.Image = (Image)new Bitmap(pictureBox1.Width, pictureBox1.Height);
            Graphics g = Graphics.FromImage(pictureBox1.Image);
            GenerateGrid(g);
            GenerateSop(g);
            GenerateGamer(g);

            if (Win())
                MessageBox.Show("Вы победили!", "Победа");
            if (Loss())
                MessageBox.Show("Вы прогирали", "Проигрыш");
        }
        private void GenerateGrid (Graphics g)
        {
            g.Clear(Color.Gainsboro);
            Pen p = new Pen(Color.Blue);
            for (int i = 0; i < GlobalWidth; i++)
                g.DrawLine(p, new Point((pictureBox1.Width / GlobalWidth * (i + 1)), 0), new Point((pictureBox1.Width / GlobalWidth * (i + 1)), pictureBox1.Height)); 
            for (int j = 0; j < GlobalHeight; j++)
                g.DrawLine(p, new Point(0, (pictureBox1.Height / GlobalHeight * (j + 1))), new Point(pictureBox1.Width, (pictureBox1.Height / GlobalHeight * (j + 1))));
        }
        private void GenerateSop(Graphics g)
        {
            for (int i = 0; i < GlobalWidth; i++)
                for (int j = 0; j < GlobalHeight; j++)
                    if (Opponents[i, j] != null)
                    {
                        g.FillRectangle(Brushes.Red, (new Rectangle((int)pictureBox1.Width / GlobalWidth * i + 3, (int)pictureBox1.Height / GlobalHeight * j + 3, (int)pictureBox1.Width / GlobalWidth - 6, (int)pictureBox1.Height / GlobalHeight - 6)));
                        g.DrawString(Opponents[i, j].ToString(), new Font("Arial", 18), Brushes.Silver, new PointF((int)pictureBox1.Width / GlobalWidth * i, (int)pictureBox1.Height / GlobalHeight * j));
                    }
        }
        private void GenerateGamer(Graphics g)
        {
            g.FillRectangle(Brushes.Green, (new Rectangle((int)pictureBox1.Width / GlobalWidth * igrok.X + 3, (int)pictureBox1.Height / GlobalHeight * igrok.Y + 3, (int)pictureBox1.Width / GlobalWidth - 6, (int)pictureBox1.Height / GlobalHeight - 6)));     
            g.DrawString(igrok.Force.ToString(), new Font("Arial", 18), Brushes.Silver, new PointF((int)pictureBox1.Width / GlobalWidth * igrok.X, (int)pictureBox1.Height / GlobalHeight * igrok.Y));                     
        }

        private void pictureBox1_SizeChanged(object sender, EventArgs e)
        {
            UpdateAll();
        }

        private void pictureBox1_MouseClick(object sender, MouseEventArgs e)
        {
            int X = pictureBox1.Width / GlobalWidth;
            int Y = pictureBox1.Height / GlobalHeight;
            for (int i = 1; i <= GlobalWidth; i++)
            {
                if (e.X <= (X * i))
                {
                    for (int j = 1; j <= GlobalHeight; j++)
                    {
                        if (e.Y <= (Y * j))
                        {
                            if(igrok.Move((i - 1), (j - 1), Opponents))
                                Spawn_Opponent();
                            UpdateAll();
                            break;
                        }
                    }
                    break;
                }
            }
        }

        private void Spawn_Opponent()
        {
            Random rnd = new Random();
            int maxlvl = GlobalHeight + GlobalWidth + 1;
            for (int i = 0; i < rnd.Next(1, Settings.Default.OpponentCount); i++)
                Opponents[rnd.Next(0, GlobalWidth), rnd.Next(0, GlobalHeight)] = Math.Abs(rnd.Next(igrok.Force - 3, maxlvl));
        }

        private bool Win()
        {
            if (igrok.Force >= GlobalHeight + GlobalWidth + 1)
                return true;
            return false;
        }

        private bool Loss()
        {
            try
            {
                if ((Opponents[igrok.X - 1, igrok.Y] > igrok.Force) && (Opponents[igrok.X + 1, igrok.Y] > igrok.Force) && (Opponents[igrok.X, igrok.Y+1] > igrok.Force) && (Opponents[igrok.X, igrok.Y-1] > igrok.Force)) 
                    return true;
            }
            catch
            {

            }
            return false;
        }

        private void newGame_Click(object sender, EventArgs e)
        {
            Opponents = new int?[GlobalWidth, GlobalHeight];
            igrok = new Player(0, 0);
            initialArr();
            UpdateAll();
        }

        private void load_Click(object sender, EventArgs e)
        {
            OpenFileDialog opf = new OpenFileDialog();
            opf.Filter = "txt files (*.txt)|*.txt|All files (*.*)|*.*";
            opf.RestoreDirectory = true;

            if (opf.ShowDialog() == DialogResult.OK)
            {
                try
                {
                    using (StreamReader sr = new StreamReader(opf.FileName))
                    {
                        string[] line = sr.ReadLine().Split(' ');
                        GlobalWidth = int.Parse(line[0]);
                        GlobalHeight = int.Parse(line[1]);
                        Opponents = new int?[GlobalWidth, GlobalHeight];

                        line = sr.ReadLine().Split(' ');
                        igrok = new Player(int.Parse(line[0]), int.Parse(line[1]), int.Parse(line[2]));
                        for (int i=0; i<int.Parse(line[3]); i++)
                        {
                            string[] oppenent = sr.ReadLine().Split(' ');
                            Opponents[int.Parse(oppenent[0]), int.Parse(oppenent[1])] = int.Parse(oppenent[2]);
                        }
                        sr.Close();
                    }
                    UpdateAll();
                }
                catch (Exception ex)
                {
                    MessageBox.Show("Ошибка при чтении фала \n " + ex.Message);
                }
            }
        }

        private void Save_Click(object sender, EventArgs e)
        {
            int OppnentsCount=0;
            for (int i = 0; i < GlobalWidth; i++)
                for (int j = 0; j < GlobalHeight; j++)
                    if (Opponents[i, j] != null)
                        OppnentsCount++;

            SaveFileDialog sfd = new SaveFileDialog();

            sfd.Filter = "txt files (*.txt)|*.txt|All files (*.*)|*.*";
            sfd.RestoreDirectory = true;

            if (sfd.ShowDialog() == DialogResult.OK)
                using (StreamWriter sw = new StreamWriter(sfd.FileName))
                {
                    sw.WriteLine(GlobalWidth + " " + GlobalHeight);
                    sw.WriteLine(igrok.X + " " + igrok.Y + " " + igrok.Force + " " + OppnentsCount);
                    for (int i = 0; i < GlobalWidth; i++)
                        for (int j = 0; j < GlobalHeight; j++)
                            if (Opponents[i, j] != null)
                                sw.WriteLine(i + " " + j + " " + Opponents[i, j]);
                    sw.Close();
                }
        }

        private void maze_Click(object sender, EventArgs e)
        {
            SettingForm SForm = new SettingForm();
            SForm.ShowDialog();
        }

        private void Form1_KeyDown(object sender, KeyEventArgs e)
        {
            try
            {
                if (e.KeyCode == Keys.Left)
                {
                    if (igrok.Move(igrok.X - 1, igrok.Y, Opponents))
                        Spawn_Opponent();
                }
                else if (e.KeyCode == Keys.Right)
                {
                    if (igrok.Move(igrok.X + 1, igrok.Y, Opponents))
                        Spawn_Opponent();
                }
                else if (e.KeyCode == Keys.Up)
                {
                    if (igrok.Move(igrok.X, igrok.Y - 1, Opponents))
                        Spawn_Opponent();
                }
                else if (e.KeyCode == Keys.Down)
                {
                    if (igrok.Move(igrok.X, igrok.Y + 1, Opponents))
                        Spawn_Opponent();
                }
            }
            catch
            {

            }
            finally
            {
                UpdateAll();
            }
        }

        private void EditorTool_Click(object sender, EventArgs e)
        {
            EditorMap EdiMap = new EditorMap(Opponents, igrok);
            EdiMap.ShowDialog();
        }
    }
}
