﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Project_VolgaIT
{
    public class Player
    {
        public int X;
        public int Y;
        public int Force;
        public Player(int inputX, int inputY)
        {
            X = inputX;
            Y = inputY;
            Force = 0;
        }
        public Player(int inputX, int inputY, int inputForce)
        {
            X = inputX;
            Y = inputY;
            Force = inputForce;
        }
        public bool Move(int toX, int toY, int?[,] Opponents)
        {
            if ((toX == X) || (toY == Y))
            {
                if (Adjacent_Cell(toX, toY))
                {
                    if (No_opponent(toX, toY, Opponents))
                    {
                        MoveTo(toX, toY);
                        return true;
                    }
                    else if (Weak_Opponent(toX, toY, Opponents))
                    {
                        MoveTo(toX, toY);
                        Opponents[toX, toY] = null;
                        return true;
                    }
                    else if (Equal_Opponent(toX, toY, Opponents))
                    {
                        MoveTo(toX, toY);
                        Opponents[toX, toY] = null;
                        Force++;
                        return true;
                    }
                }
                else
                    if (motion(toX, toY, Opponents))
                    {
                        if (Equal_Opponent(toX, toY, Opponents))
                            Force++;
                        Clear_Opponent(toX, toY, Opponents);
                        MoveTo(toX, toY);
                        return true;
                    }
            }
            else
                MessageBox.Show("Передвижение на эту клетку невозможно", "Ошибка");
            return false;
        }

        private bool No_opponent(int tX, int tY, int?[,] Opponents)
        {
            if (Opponents[tX, tY] == null)
                return true;
            return false;
        }

        private bool Adjacent_Cell(int tX, int tY)
        {
            if ((Math.Abs(X-tX)==1)||(Math.Abs(Y-tY)==1))
                return true;
            return false;
        }

        private bool Equal_Opponent(int tX, int tY, int?[,] Opponents)
        {
            if (Opponents[tX, tY] == Force)
                return true;
            return false;
        }
        private bool Weak_Opponent(int tX, int tY, int?[,] Opponents)
        {
            if (Opponents[tX, tY] < Force)
                return true;
            return false;
        }
        private bool motion(int tX, int tY, int?[,] Opponents)
        {
            if (X == tX)
            {
                if (Y < tY)
                {
                    for (int i = Y; i <= tY; i++)
                        if (Opponents[tX, i] > Force)
                            //    MoveTo(X, i);//Движение вниз
                            //else
                            return false;
                }
                else
                {
                    for (int i = Y; i >= tY; i--)
                        if (Opponents[tX, i] > Force)
                            //    MoveTo(X, i);//Движение вверх
                            //else
                            return false;
                }
            }
            else
                if (Y == tY)
                {
                    if (X < tX)
                    {
                        for (int i = X; i <= tX; i++)
                            if (Opponents[i, tY] > Force)
                                //    MoveTo(i, Y);//Движение вправо
                                //else
                                return false;
                    }
                    else
                    {
                        for (int i = X; i >= tX; i--)
                            if (Opponents[i, tY] > Force)
                                //    MoveTo(i, Y);//Движение влево
                                //else
                                return false;
                    }
                }
            return true;
        }

        private void Clear_Opponent(int tX, int tY, int?[,] Opponents)
        {
            if (X == tX)
            {
                if (Y < tY)
                {
                    for (int i = Y; i <= tY; i++)
                    {
                        if (Equal_Opponent(tX, i, Opponents))
                            Force++;
                        Opponents[tX, i] = null;//Движение вниз
                    }
                }
                else
                {
                    for (int i = Y; i >= tY; i--)
                    {
                        if (Equal_Opponent(tX, i, Opponents))
                            Force++;
                        Opponents[tX, i] = null;//Движение вверх
                    }
                }
            }
            else
                if (Y == tY)
                {
                    if (X < tX)
                    {
                        for (int i = X; i <= tX; i++)
                        {
                            if (Equal_Opponent(i, tY, Opponents))
                                Force++;
                            Opponents[i, tY] = null;//Движение вправо
                        }
                    }
                    else
                    {
                        for (int i = X; i >= tX; i--)
                        {
                            if (Equal_Opponent(i, tY, Opponents))
                                Force++;
                            Opponents[i, tY] = null;//Движение влево
                        }
                    }
                }
        }

        private void MoveTo(int tX, int tY)
        {
            X = tX;
            Y = tY;
        }
    }
}
